// DCGSBinExpr.h
#ifndef _DCGSBINEXPR_H_
#define _DCGSBINEXPR_H_
#define _BINEXPR_H_
//#include "defs.h"
//#include "expr.h"
#include "DCGSexpr.h"
class BinExpr : Expr {
	//BINOP op;
	//int priority;
	//expression *Left;
	//expression *Right;
	//expression *left();
	//expression *right();
	BinExpr(BINOP op, expression *left, expression *right);
	//friend Expr *createExpr1(BINOP op, expression *left, expression *right);
	//friend Expr *createExpr1(char *op, expression *left, expression *right);
	//friend bool deleteExpr(BinExpr *ex);
	//friend bool deleteExpression(expression *ex);
	//friend bool deleteSymbol(expression **smb1, int flags);
	int printpar(int priority);
	int printpar(FILE *f, char *fmt, int priority);
	virtual constvar &evalInt();
	constvar &evalIntEQ();
	int evalprintInt(FILE *f, char *fmt,constvar res);
	//friend void *generateCodeBinExpr(void *buff,expression *pgm,int registers,int regResult);
	//friend void *generateCodeBinAssign(void *buff,expression *pgm,int registers,int regResult);
	//friend void *generateCodeBinADD(void *buf,expression *pgm,int registers,int regResult);
	//friend void *generateCodeBinSUB(void *buf,expression *pgm,int registers,int regResult);
	//friend void *generateCodeBinMUL(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinDIV(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinMOD(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinEQ(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinNEQ(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinGT(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinLT(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinGE(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinLE(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinAND(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinOR(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinXOR(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinSAL(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinSAR(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinLAND(void *buf,expression *pgm,int registerR,int regResult);
	//friend void *generateCodeBinLOR(void *buf,expression *pgm,int registerR,int regResult);
	//friend class DebugObj;
public:
	int print();
	int print(FILE *f, char *fmt);
	virtual constvar &eval();
	virtual constvar &typedEval(Const typeV);
	virtual int getType();
	virtual int printExpr();					// print expression internal mode
	virtual int printExpr(FILE *f,char *fmt);
	int evalprint(FILE *f=stdout, char *fmt="");
	int typedEvalprint(FILE *f, char *fmt,Const tp);
	int evalprint();
};
Expr *createExpr1(BINOP op, expression *left, expression *right);
Expr *createExpr1(char *op, expression *left, expression *right);
#endif