// DCGSgenasm.h
#ifndef _DCGSGENASM_H_
#define _DCGSGENASM_H_

typedef void (*GENERATED)();
#define call(b) callFunConstvar((GENERATED)b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callConstvar(b) callFunConstvar((GENERATED)b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callLong(b) callFunLong((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callVariable(b) callFunVariable((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callInt(b) callFunInt((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callShort(b) callFunShort((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callChar(b) callFunChar((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callString(b) callFunString((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callFloat(b) callFunFloat((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callDouble(b) callFunDouble((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callVoid(b) callFunVoid((GENERATED) b->getStartBuffer(__LINE__,__FUNCTION__,__FILE__),b)
#define callExpression callVariable
class header;
constvar callFunConstvar(GENERATED f, header *compiledPgm);
constvar callFun(GENERATED f, header *compiledPgm);
long callFunLong(GENERATED f, header *compiledPgm);
int callFunInt(GENERATED f, header *compiledPgm);
short callFunShort(GENERATED f, header *compiledPgm);
char callFunChar(GENERATED f, header *compiledPgm);
char *callFunString(GENERATED f, header *compiledPgm);
float callFunFloat(GENERATED f, header *compiledPgm);
double callFunDouble(GENERATED f, header *compiledPgm);
void *callFunVoid(GENERATED f, header *compiledPgm);
expression *callFunVariable(GENERATED f, header *compiledPgm);

#endif